Crypto++

- Main Page
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Types | Public Member Functions | Protected Member Functions | Protected Attributes
AdditiveCipherTemplate< BASE > Class Template Reference
Inheritance diagram for AdditiveCipherTemplate< BASE >:

List of all members.

## Public Types

typedef BASE::PolicyInterface | PolicyInterface

## Public Member Functions

void | GenerateBlock (byte *output, size_t size)
| generate random array of bytes
void | ProcessData (byte *outString, const byte *inString, size_t length)
void | Resynchronize (const byte *iv, int length=-1)
unsigned int | OptimalBlockSize () const
unsigned int | GetOptimalNextBlockSize () const
unsigned int | OptimalDataAlignment () const
bool | IsSelfInverting () const
bool | IsForwardTransformation () const
bool | IsRandomAccess () const
void | Seek (lword position)
virtual void | IncorporateEntropy (const byte *input, size_t length)
| update RNG state with additional unpredictable values
virtual bool | CanIncorporateEntropy () const
| returns true if IncorporateEntropy is implemented
virtual byte | GenerateByte ()
| generate new random byte and return it
virtual unsigned int | GenerateBit ()
| generate new random bit and return it
virtual word32 | GenerateWord32 (word32 a=0, word32 b=0xffffffffL)
| generate a random 32 bit word in the range min to max, inclusive
virtual void | DiscardBytes (size_t n)
| generate and discard n bytes
virtual void | GenerateIntoBufferedTransformation (BufferedTransformation &target, const std::string &channel, lword length)
| generate random bytes as input to a BufferedTransformation
template<class IT >
void | Shuffle (IT begin, IT end)
| randomly shuffle the specified array, resulting permutation is uniformly distributed
virtual std::string | AlgorithmName () const
| returns name of this algorithm, not universally implemented yet
virtual Clonable * | Clone () const
| this is not implemented by most classes yet

## Protected Member Functions

void | UncheckedSetKey (const byte *key, unsigned int length, const NameValuePairs &params)
unsigned int | GetBufferByteSize (const PolicyInterface &policy) const
byte * | KeystreamBufferBegin ()
byte * | KeystreamBufferEnd ()

## Protected Attributes

SecByteBlock | m_buffer
size_t | m_leftOver

## Detailed Description

### template<class BASE = AbstractPolicyHolder<AdditiveCipherAbstractPolicy, SymmetricCipher>>
class AdditiveCipherTemplate< BASE >

Definition at line 134 of file strciphr.h.

## Member Function Documentation

virtual unsigned int RandomNumberGenerator::GenerateBit | ( |  | ) | `[virtual, inherited]`

generate new random bit and return it

Default implementation is to call GenerateByte() and return its lowest bit.

Reimplemented in PublicBlumBlumShub.

The documentation for this class was generated from the following file:

- strciphr.h